diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/test/test-circular-aperture-antenna.cc ns-3.44/src/antenna/test/test-circular-aperture-antenna.cc
--- ns-3.43/src/antenna/test/test-circular-aperture-antenna.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/test/test-circular-aperture-antenna.cc	2025-03-09 16:55:49.343371000 -0700
@@ -4,6 +4,7 @@
  *   SPDX-License-Identifier: GPL-2.0-only
  */
 
+#include "ns3/boolean.h"
 #include "ns3/circular-aperture-antenna-model.h"
 #include "ns3/double.h"
 #include "ns3/log.h"
@@ -23,9 +24,9 @@
 NS_LOG_COMPONENT_DEFINE("TestCircularApertureAntennaModel");
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief CircularApertureAntennaModel Test Case
+ * @brief CircularApertureAntennaModel Test Case
  *
  * Note: Since Clang libc++ does not support the Mathematical special functions (P0226R1) yet, this
  * class falls back to Boost's implementation of cyl_bessel_j whenever the above standard library is
@@ -37,7 +38,7 @@
     CircularApertureAntennaModelTestCase();
 
     /**
-     * \brief Description of a single test point
+     * @brief Description of a single test point
      *
      * Description of a test point, which is characterized
      * by the CircularApertureAntennaModel parameters,
@@ -56,6 +57,7 @@
          * @param testAzimuth test azimuth [rad]
          * @param testInclination test inclination [rad]
          * @param expectedGain the expected gain value [dB]
+         * @param forceGainBounds restrict or not gain range to [antennaMinGainDb, antennaMaxGainDb]
          */
         TestPoint(double antennaMaxGainDb,
                   double antennaMinGainDb,
@@ -63,14 +65,16 @@
                   double operatingFrequency,
                   double testAzimuth,
                   double testInclination,
-                  double expectedGain)
+                  double expectedGain,
+                  bool forceGainBounds)
             : m_antennaMaxGainDb(antennaMaxGainDb),
               m_antennaMinGainDb(antennaMinGainDb),
               m_antennaCircularApertureRadius(antennaCircularApertureRadius),
               m_operatingFrequency(operatingFrequency),
               m_testAzimuth(DegreesToRadians(testAzimuth)),
               m_testInclination(DegreesToRadians(testInclination)),
-              m_expectedGain(expectedGain)
+              m_expectedGain(expectedGain),
+              m_forceGainBounds(forceGainBounds)
         {
         }
 
@@ -81,12 +85,13 @@
         double m_testAzimuth;                   ///< test azimuth [rad]
         double m_testInclination;               ///< test inclination [rad]
         double m_expectedGain;                  ///< the expected gain value [dB]
+        bool m_forceGainBounds;                 ///< enable bounds checking for GetGainDb
     };
 
     /**
      * Generate a string containing all relevant parameters
-     * \param testPoint the parameter configuration to be tested
-     * \return the string containing all relevant parameters
+     * @param testPoint the parameter configuration to be tested
+     * @return the string containing all relevant parameters
      */
     static std::string BuildNameString(TestPoint testPoint);
 
@@ -95,7 +100,7 @@
      * by comparing the antenna gain obtained using CircularApertureAntennaModel::GetGainDb
      * and the one obtained using MATLAB.
      *
-     * \param testPoint the parameter configuration to be tested
+     * @param testPoint the parameter configuration to be tested
      */
     void TestAntennaGain(TestPoint testPoint);
 
@@ -136,7 +141,9 @@
             "AntennaCircularApertureRadius",
             DoubleValue(testPoint.m_antennaCircularApertureRadius),
             "OperatingFrequency",
-            DoubleValue(testPoint.m_operatingFrequency));
+            DoubleValue(testPoint.m_operatingFrequency),
+            "ForceGainBounds",
+            BooleanValue(testPoint.m_forceGainBounds));
 
     Ptr<UniformPlanarArray> upa =
         CreateObjectWithAttributes<UniformPlanarArray>("AntennaElement",
@@ -164,45 +171,50 @@
         // MaxGainDb  MinGainDb  Radius (m)  Freq (Hz)   Azimuth (deg)  Incl (deg)  ExpGain (dB)
         // Test invariant: gain always equal to max gain at boresight (inclination 90, azimuth = 0)
         // for different frequency
-        {30, -30, 0.5, 2e9, 0, 90, 30},
-        {30, -30, 2, 20e9, 0, 90, 30},
+        {30, -30, 0.5, 2e9, 0, 90, 30, false},
+        {30, -30, 2, 20e9, 0, 90, 30, false},
         // Test invariant: gain always equal to max gain at boresight (inclination 90, azimuth = 0)
         // for different max gain
-        {20, -30, 0.5, 2e9, 0, 90, 20},
-        {10, -30, 2, 20e9, 0, 90, 10},
+        {20, -30, 0.5, 2e9, 0, 90, 20, false},
+        {10, -30, 2, 20e9, 0, 90, 10, false},
         // Test invariant: gain always equal to min gain outside of |theta| < 90 deg
         // for different frequency
-        {30, -100, 0.5, 2e9, 0, 0, -100},
-        {30, -100, 2, 20e9, 0, 0, -100},
+        {30, -100, 0.5, 2e9, 0, 0, -100, false},
+        {30, -100, 2, 20e9, 0, 0, -100, false},
         // Test invariant: gain always equal to min gain outside of |theta| < 90 deg
         // for different orientations
-        {30, -100, 0.5, 2e9, 180, 90, -100},
-        {30, -100, 2, 20e9, -180, 90, -100},
+        {30, -100, 0.5, 2e9, 180, 90, -100, false},
+        {30, -100, 2, 20e9, -180, 90, -100, false},
         // Fixed elevation to boresight (90deg) and azimuth varying in [-90, 0] deg with steps of 10
         // degrees
-        {0, -50, 0.10707, 28000000000, -90, 90, -50},
-        {0, -50, 0.10707, 28000000000, -80, 90, -49.8022},
-        {0, -50, 0.10707, 28000000000, -70, 90, -49.1656},
-        {0, -50, 0.10707, 28000000000, -60, 90, -60.9132},
-        {0, -50, 0.10707, 28000000000, -50, 90, -59.2368},
-        {0, -50, 0.10707, 28000000000, -40, 90, -44.6437},
-        {0, -50, 0.10707, 28000000000, -30, 90, -43.9686},
-        {0, -50, 0.10707, 28000000000, -20, 90, -36.3048},
-        {0, -50, 0.10707, 28000000000, -10, 90, -30.5363},
-        {0, -50, 0.10707, 28000000000, 0, 90, 0},
+        {0, -50, 0.10707, 28000000000, -90, 90, -50, false},
+        {0, -50, 0.10707, 28000000000, -80, 90, -49.8022, false},
+        {0, -50, 0.10707, 28000000000, -70, 90, -49.1656, false},
+        {0, -50, 0.10707, 28000000000, -60, 90, -60.9132, false},
+        {0, -50, 0.10707, 28000000000, -60, 90, -50, true},
+        {0, -50, 0.10707, 28000000000, -50, 90, -59.2368, false},
+        {0, -50, 0.10707, 28000000000, -50, 90, -50, true},
+        {0, -50, 0.10707, 28000000000, -40, 90, -44.6437, false},
+        {0, -50, 0.10707, 28000000000, -30, 90, -43.9686, false},
+        {0, -50, 0.10707, 28000000000, -20, 90, -36.3048, false},
+        {0, -50, 0.10707, 28000000000, -10, 90, -30.5363, false},
+        {0, -50, 0.10707, 28000000000, 0, 90, 0, false},
         // Fixed azimuth to boresight (0 deg) and azimuth varying in [0, 90] deg with steps of 9
         // degrees
-        {0, -50, 0.10707, 28e9, 0, 0, -50},
-        {0, -50, 0.10707, 28e9, 0, 9, -49.7256},
-        {0, -50, 0.10707, 28e9, 0, 18, -52.9214},
-        {0, -50, 0.10707, 28e9, 0, 27, -48.6077},
-        {0, -50, 0.10707, 28e9, 0, 36, -60.684},
-        {0, -50, 0.10707, 28e9, 0, 45, -55.1468},
-        {0, -50, 0.10707, 28e9, 0, 54, -42.9648},
-        {0, -50, 0.10707, 28e9, 0, 63, -45.6472},
-        {0, -50, 0.10707, 28e9, 0, 72, -48.6378},
-        {0, -50, 0.10707, 28e9, 0, 81, -35.1613},
-        {0, -50, 0.10707, 28e9, 0, 90, 0}};
+        {0, -50, 0.10707, 28e9, 0, 0, -50, false},
+        {0, -50, 0.10707, 28e9, 0, 9, -49.7256, false},
+        {0, -50, 0.10707, 28e9, 0, 18, -52.9214, false},
+        {0, -50, 0.10707, 28e9, 0, 18, -50, true},
+        {0, -50, 0.10707, 28e9, 0, 27, -48.6077, false},
+        {0, -50, 0.10707, 28e9, 0, 36, -60.684, false},
+        {0, -50, 0.10707, 28e9, 0, 36, -50, true},
+        {0, -50, 0.10707, 28e9, 0, 45, -55.1468, false},
+        {0, -50, 0.10707, 28e9, 0, 45, -50, true},
+        {0, -50, 0.10707, 28e9, 0, 54, -42.9648, false},
+        {0, -50, 0.10707, 28e9, 0, 63, -45.6472, false},
+        {0, -50, 0.10707, 28e9, 0, 72, -48.6378, false},
+        {0, -50, 0.10707, 28e9, 0, 81, -35.1613, false},
+        {0, -50, 0.10707, 28e9, 0, 90, 0, false}};
 
     // Call TestAntennaGain on each test point
     for (auto& point : testPoints)
@@ -212,9 +224,9 @@
 }
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief UniformPlanarArray Test Suite
+ * @brief UniformPlanarArray Test Suite
  */
 class CircularApertureAntennaModelTestSuite : public TestSuite
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/test/test-cosine-antenna.cc ns-3.44/src/antenna/test/test-cosine-antenna.cc
--- ns-3.43/src/antenna/test/test-cosine-antenna.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/test/test-cosine-antenna.cc	2025-03-09 16:55:49.343371000 -0700
@@ -6,11 +6,11 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include <ns3/cosine-antenna-model.h>
-#include <ns3/double.h>
-#include <ns3/log.h>
-#include <ns3/simulator.h>
-#include <ns3/test.h>
+#include "ns3/cosine-antenna-model.h"
+#include "ns3/double.h"
+#include "ns3/log.h"
+#include "ns3/simulator.h"
+#include "ns3/test.h"
 
 #include <cmath>
 #include <iostream>
@@ -22,9 +22,9 @@
 NS_LOG_COMPONENT_DEFINE("TestCosineAntennaModel");
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief Test condition (equal to or less than)
+ * @brief Test condition (equal to or less than)
  */
 enum CosineAntennaModelGainTestCondition
 {
@@ -33,30 +33,30 @@
 };
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief CosineAntennaModel Test
+ * @brief CosineAntennaModel Test
  */
 class CosineAntennaModelTestCase : public TestCase
 {
   public:
     /**
      * Build the test name
-     * \param a Antenna angle
-     * \param b Horizontal and Vertical Beamwidth
-     * \param o Orientation
-     * \param g MaxGain
-     * \return the test name
+     * @param a Antenna angle
+     * @param b Horizontal and Vertical Beamwidth
+     * @param o Orientation
+     * @param g MaxGain
+     * @return the test name
      */
     static std::string BuildNameString(Angles a, double b, double o, double g);
     /**
      * Constructor
-     * \param a Antenna angle
-     * \param b Horizontal and Vertical Beamwidth
-     * \param o Orientation
-     * \param g MaxGain
-     * \param expectedGainDb Expected antenna gain
-     * \param cond Test condition
+     * @param a Antenna angle
+     * @param b Horizontal and Vertical Beamwidth
+     * @param o Orientation
+     * @param g MaxGain
+     * @param expectedGainDb Expected antenna gain
+     * @param cond Test condition
      */
     CosineAntennaModelTestCase(Angles a,
                                double b,
@@ -129,9 +129,9 @@
 }
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief CosineAntennaModel TestSuite
+ * @brief CosineAntennaModel TestSuite
  */
 class CosineAntennaModelTestSuite : public TestSuite
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/test/test-degrees-radians.cc ns-3.44/src/antenna/test/test-degrees-radians.cc
--- ns-3.43/src/antenna/test/test-degrees-radians.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/test/test-degrees-radians.cc	2025-03-09 16:55:49.343371000 -0700
@@ -6,9 +6,9 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include <ns3/antenna-model.h>
-#include <ns3/log.h>
-#include <ns3/test.h>
+#include "ns3/antenna-model.h"
+#include "ns3/log.h"
+#include "ns3/test.h"
 
 #include <cmath>
 #include <iostream>
@@ -18,23 +18,23 @@
 using namespace ns3;
 
 /**
- * \ingroup tests
+ * @ingroup tests
  *
- * \brief Test degree to radians conversion
+ * @brief Test degree to radians conversion
  */
 class DegreesToRadiansTestCase : public TestCase
 {
   public:
     /**
      * Build the test name
-     * \param a test param
-     * \return the test name
+     * @param a test param
+     * @return the test name
      */
     static std::string BuildNameString(double a);
     /**
      * Constructor
-     * \param a angle in degrees
-     * \param b expected angle in radians
+     * @param a angle in degrees
+     * @param b expected angle in radians
      */
     DegreesToRadiansTestCase(double a, double b);
 
@@ -67,23 +67,23 @@
 }
 
 /**
- * \ingroup tests
+ * @ingroup tests
  *
- * \brief Test radians to degree conversion
+ * @brief Test radians to degree conversion
  */
 class RadiansToDegreesTestCase : public TestCase
 {
   public:
     /**
      * Build the test name
-     * \param a test param
-     * \return the test name
+     * @param a test param
+     * @return the test name
      */
     static std::string BuildNameString(double a);
     /**
      * Constructor
-     * \param a angle in radians
-     * \param b expected angle in degrees
+     * @param a angle in radians
+     * @param b expected angle in degrees
      */
     RadiansToDegreesTestCase(double a, double b);
 
@@ -116,9 +116,9 @@
 }
 
 /**
- * \ingroup tests
+ * @ingroup tests
  *
- * \brief TestSuite: degree to radians (and vice-versa) conversions
+ * @brief TestSuite: degree to radians (and vice-versa) conversions
  */
 class DegreesRadiansTestSuite : public TestSuite
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/test/test-isotropic-antenna.cc ns-3.44/src/antenna/test/test-isotropic-antenna.cc
--- ns-3.43/src/antenna/test/test-isotropic-antenna.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/test/test-isotropic-antenna.cc	2025-03-09 16:55:49.343371000 -0700
@@ -6,9 +6,9 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include <ns3/isotropic-antenna-model.h>
-#include <ns3/log.h>
-#include <ns3/test.h>
+#include "ns3/isotropic-antenna-model.h"
+#include "ns3/log.h"
+#include "ns3/test.h"
 
 #include <cmath>
 #include <iostream>
@@ -18,23 +18,23 @@
 using namespace ns3;
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief IsotropicAntennaModel Test
+ * @brief IsotropicAntennaModel Test
  */
 class IsotropicAntennaModelTestCase : public TestCase
 {
   public:
     /**
      * Build the test name
-     * \param a Antenna angle
-     * \return the test name
+     * @param a Antenna angle
+     * @return the test name
      */
     static std::string BuildNameString(Angles a);
     /**
      * Constructor
-     * \param a Antenna angle
-     * \param expectedGainDb Expected antenna gain
+     * @param a Antenna angle
+     * @param expectedGainDb Expected antenna gain
      */
     IsotropicAntennaModelTestCase(Angles a, double expectedGainDb);
 
@@ -72,9 +72,9 @@
 }
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief IsotropicAntennaModel TestSuite
+ * @brief IsotropicAntennaModel TestSuite
  */
 class IsotropicAntennaModelTestSuite : public TestSuite
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/test/test-parabolic-antenna.cc ns-3.44/src/antenna/test/test-parabolic-antenna.cc
--- ns-3.43/src/antenna/test/test-parabolic-antenna.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/test/test-parabolic-antenna.cc	2025-03-09 16:55:49.343371000 -0700
@@ -6,11 +6,11 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include <ns3/double.h>
-#include <ns3/log.h>
-#include <ns3/parabolic-antenna-model.h>
-#include <ns3/simulator.h>
-#include <ns3/test.h>
+#include "ns3/double.h"
+#include "ns3/log.h"
+#include "ns3/parabolic-antenna-model.h"
+#include "ns3/simulator.h"
+#include "ns3/test.h"
 
 #include <cmath>
 #include <iostream>
@@ -22,9 +22,9 @@
 NS_LOG_COMPONENT_DEFINE("TestParabolicAntennaModel");
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief Test condition (equal to or less than)
+ * @brief Test condition (equal to or less than)
  */
 enum ParabolicAntennaModelGainTestCondition
 {
@@ -33,30 +33,30 @@
 };
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief ParabolicAntennaModel Test
+ * @brief ParabolicAntennaModel Test
  */
 class ParabolicAntennaModelTestCase : public TestCase
 {
   public:
     /**
      * Build the test name
-     * \param a Antenna angle
-     * \param b Beamwidth
-     * \param o Orientation
-     * \param g MaxGain
-     * \return the test name
+     * @param a Antenna angle
+     * @param b Beamwidth
+     * @param o Orientation
+     * @param g MaxGain
+     * @return the test name
      */
     static std::string BuildNameString(Angles a, double b, double o, double g);
     /**
      * Constructor
-     * \param a Antenna angle
-     * \param b Beamwidth
-     * \param o Orientation
-     * \param g MaxGain
-     * \param expectedGainDb Expected antenna gain
-     * \param cond Test condition
+     * @param a Antenna angle
+     * @param b Beamwidth
+     * @param o Orientation
+     * @param g MaxGain
+     * @param expectedGainDb Expected antenna gain
+     * @param cond Test condition
      */
     ParabolicAntennaModelTestCase(Angles a,
                                   double b,
@@ -130,9 +130,9 @@
 }
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief ParabolicAntennaModel TestSuite
+ * @brief ParabolicAntennaModel TestSuite
  */
 class ParabolicAntennaModelTestSuite : public TestSuite
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/test/test-uniform-planar-array.cc ns-3.44/src/antenna/test/test-uniform-planar-array.cc
--- ns-3.43/src/antenna/test/test-uniform-planar-array.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/test/test-uniform-planar-array.cc	2025-03-09 16:55:49.343371000 -0700
@@ -24,24 +24,24 @@
 NS_LOG_COMPONENT_DEFINE("TestUniformPlanarArray");
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief UniformPlanarArray Test Case
+ * @brief UniformPlanarArray Test Case
  */
 class UniformPlanarArrayTestCase : public TestCase
 {
   public:
     /**
      * Generate a string containing all relevant parameters
-     * \param element the antenna element
-     * \param rows the number of rows
-     * \param cols the number of columns
-     * \param rowSpace the row spacing
-     * \param colSpace the column spacing
-     * \param alpha the bearing angle
-     * \param beta the tilting angle
-     * \param direction the direction
-     * \return the string containing all relevant parameters
+     * @param element the antenna element
+     * @param rows the number of rows
+     * @param cols the number of columns
+     * @param rowSpace the row spacing
+     * @param colSpace the column spacing
+     * @param alpha the bearing angle
+     * @param beta the tilting angle
+     * @param direction the direction
+     * @return the string containing all relevant parameters
      */
     static std::string BuildNameString(Ptr<AntennaModel> element,
                                        uint32_t rows,
@@ -53,15 +53,15 @@
                                        Angles direction);
     /**
      * The constructor of the test case
-     * \param element the antenna element
-     * \param rows the number of rows
-     * \param cols the number of columns
-     * \param rowSpace the row spacing
-     * \param colSpace the column spacing
-     * \param alpha the bearing angle
-     * \param beta the tilting angle
-     * \param direction the direction
-     * \param expectedGainDb the expected antenna gain [dB]
+     * @param element the antenna element
+     * @param rows the number of rows
+     * @param cols the number of columns
+     * @param rowSpace the row spacing
+     * @param colSpace the column spacing
+     * @param alpha the bearing angle
+     * @param beta the tilting angle
+     * @param direction the direction
+     * @param expectedGainDb the expected antenna gain [dB]
      */
     UniformPlanarArrayTestCase(Ptr<AntennaModel> element,
                                uint32_t rows,
@@ -80,8 +80,8 @@
     void DoRun() override;
     /**
      * Compute the gain of the antenna array
-     * \param a the antenna array
-     * \return the gain of the antenna array [dB]
+     * @param a the antenna array
+     * @return the gain of the antenna array [dB]
      */
     double ComputeGain(Ptr<UniformPlanarArray> a);
 
@@ -193,9 +193,79 @@
 }
 
 /**
- * \ingroup antenna-tests
+ * @ingroup antenna-tests
  *
- * \brief UniformPlanarArray Test Suite
+ * @brief UpdateOnChange Test Case
+ */
+class UpdateOnChangeTestCase : public TestCase
+{
+  public:
+    /**
+     * The constructor of the test case
+     * @param element the antenna element
+     * @param name the test case name
+     */
+    UpdateOnChangeTestCase(Ptr<AntennaModel> element, std::string name)
+        : TestCase(name),
+          m_element(element){};
+
+  private:
+    /**
+     * Run the test
+     */
+    void DoRun() override;
+    Ptr<AntennaModel> m_element; //!< the antenna element
+};
+
+void
+UpdateOnChangeTestCase::DoRun()
+{
+    Ptr<UniformPlanarArray> ant = CreateObject<UniformPlanarArray>();
+    ant->SetAttribute("AntennaElement", PointerValue(m_element));
+    ant->SetAttribute("NumRows", UintegerValue(10));
+    ant->SetAttribute("NumColumns", UintegerValue(10));
+    ant->SetAttribute("AntennaVerticalSpacing", DoubleValue(0.5));
+    ant->SetAttribute("AntennaHorizontalSpacing", DoubleValue(0.5));
+    ant->SetAttribute("BearingAngle", DoubleValue(DegreesToRadians(0)));
+    ant->SetAttribute("DowntiltAngle", DoubleValue(DegreesToRadians(45)));
+
+    Ptr<UniformPlanarArray> ant2 = CreateObject<UniformPlanarArray>();
+    ant2->SetAttribute("AntennaElement", PointerValue(m_element));
+    ant2->SetAttribute("NumRows", UintegerValue(10));
+    ant2->SetAttribute("NumColumns", UintegerValue(10));
+    ant2->SetAttribute("AntennaVerticalSpacing", DoubleValue(0.5));
+    ant2->SetAttribute("AntennaHorizontalSpacing", DoubleValue(0.5));
+    ant2->SetAttribute("BearingAngle", DoubleValue(DegreesToRadians(0)));
+    ant2->SetAttribute("DowntiltAngle", DoubleValue(DegreesToRadians(45)));
+
+    NS_TEST_ASSERT_MSG_EQ(ant.operator bool(), true, "AntennaModel is not a PhasedArrayModel");
+
+    // Initial state of array requires a channel update
+    NS_TEST_ASSERT_MSG_EQ(ant->IsChannelOutOfDate(ant2),
+                          true,
+                          "Expecting update, since the pair was never setup");
+    NS_TEST_ASSERT_MSG_EQ(
+        ant2->IsChannelOutOfDate(ant),
+        false,
+        "Not expecting update, since the pair was just updated and no settings changed");
+    ant->SetAlpha(DegreesToRadians(90));
+    NS_TEST_ASSERT_MSG_EQ(ant2->IsChannelOutOfDate(ant),
+                          true,
+                          "Expecting update, antenna parameter changed");
+    NS_TEST_ASSERT_MSG_EQ(
+        ant->IsChannelOutOfDate(ant2),
+        false,
+        "Not expecting update, since the pair was just updated and no settings changed");
+    ant->SetAlpha(DegreesToRadians(90));
+    NS_TEST_ASSERT_MSG_EQ(ant->IsChannelOutOfDate(ant2),
+                          true,
+                          "Expecting update, antenna parameter changed");
+}
+
+/**
+ * @ingroup antenna-tests
+ *
+ * @brief UniformPlanarArray Test Suite
  */
 class UniformPlanarArrayTestSuite : public TestSuite
 {
@@ -377,6 +447,10 @@
                                                Angles(DegreesToRadians(0), DegreesToRadians(135)),
                                                28.0),
                 TestCase::Duration::QUICK);
+    AddTestCase(new UpdateOnChangeTestCase(tgpp,
+                                           "Test IsChannelOutOfDate() and InvalidateChannels() for "
+                                           "UniformPlanarArray with 3GPP antenna element"),
+                TestCase::Duration::QUICK);
 }
 
 static UniformPlanarArrayTestSuite staticUniformPlanarArrayTestSuiteInstance;
